//+------------------------------------------------------------------+
//|                                                 AddSignal_v1.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"
//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1

//---- indicator parameters
extern int  haMA1_Period   =     5;    // Period of fast MAofHA
extern int  haMA1_Mode     =     3;    // Method of fast MAofHA
extern int  haMA2_Period   =    10;    // Period of slow MAofHA
extern int  haMA2_Mode     =     2;    // Method of slow MAofHA
extern int  MACD_Fast      =     8;    //    
extern int  MACD_Slow      =    21;    //
extern int  MACD_Signal    =     5;    // 
extern int  MACD_MAMode    =     1;    // Mode of MACD
extern int  Len            =     4; // Period of evaluation
extern int  AlertMode      =     0;    // Alert Mode: 0-off,1-on

//---- indicator buffers
double UpSignal[];
double DnSignal[]; 
double trend[];

bool   UpTrendAlert=false, DownTrendAlert=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name;
//---- drawing settings
   IndicatorBuffers(7);
      
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- indicator short name
   IndicatorShortName("AddSignal");
   SetIndexLabel(0,"UpSignal");
   SetIndexLabel(1,"DnSignal");
   SetIndexDrawBegin(0,MACD_Slow+MACD_Signal);
   SetIndexDrawBegin(1,MACD_Slow+MACD_Signal);
//---- indicator buffers mapping
   SetIndexBuffer(0,UpSignal);
   SetIndexBuffer(1,DnSignal);
   SetIndexBuffer(2,trend);
   
//---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int limit;
   if(Bars<=MACD_Slow+MACD_Signal) return(0);
   int CountedBars=IndicatorCounted();
//---- check for possible errors
   if (CountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (CountedBars>0) CountedBars--;
   limit=Bars-CountedBars;
//---- 
   for(int i=limit; i>=0; i--)
   { 
   double RSI = iCustom(NULL,0,"Turbo JRSX",Len,0,i);
   
   double haMA1 = iCustom(Symbol(),0,"MAofHA_v1",0,haMA1_Period,0,haMA1_Mode,0,i);
   double haMA2 = iCustom(Symbol(),0,"MAofHA_v1",0,haMA2_Period,0,haMA2_Mode,0,i);

   int m = MACD_MAMode;
   
   double MACD = iCustom(Symbol(),0,"MACDofHA_v1",0,MACD_Fast,m,MACD_Slow,m,MACD_Signal,m,0,i);
   double SigMACD = iCustom(Symbol(),0,"MACDofHA_v1",0,MACD_Fast,m,MACD_Slow,m,MACD_Signal,m,1,i);
   
   trend[i]=trend[i+1]; 
   if (RSI > 50 && haMA1>haMA2 && MACD>SigMACD) trend[i]= 1; 
   if (RSI < 50 && haMA1<haMA2 && MACD<SigMACD) trend[i]=-1; 
      
      if(trend[i]>0)
	   {
	   if (trend[i+1]<0) UpSignal[i] = Low[i]-0.5*iATR(NULL,0,10,i);
	   DnSignal[i]=EMPTY_VALUE; 
	   }
	   else
	   if(trend[i]<0)
	   {
	   if (trend[i+1]>0) DnSignal[i] = High[i]+0.5*iATR(NULL,0,10,i);
	   UpSignal[i]=EMPTY_VALUE; 
	   }
   	         
//----------   
      if (i==0 && AlertMode > 0)
      {
         if (trend[i+1] > 0 && Volume[0]>1)
         {
            if (trend[i+2]<0 && !UpTrendAlert)
	         {
	         string Message = " "+Symbol()+" M"+Period()+": Signal for BUY";
	         Alert (Message); 
	         UpTrendAlert=true; DownTrendAlert=false;
	         } 
	      }
	      else
	      if (trend[i+1] < 0 && Volume[0]>1)
	      {
            if ( trend[i+2]>0 && !DownTrendAlert)
	         {
	         Message = " "+Symbol()+" M"+Period()+": Signal for SELL";
	         Alert (Message); 
	         DownTrendAlert=true; UpTrendAlert=false;     
	         }
	      } 	  
      }	
	} 	         

//---- done
   return(0);
}
//+------------------------------------------------------------------+